{
   "    ". (c) . 
 .
Embarcadero Delphi 10.2 Tokyo.
Delphi-: TES_bayes.
     : FreeWare (    -  ).
  .  : ES_Bayes.pdf
===
(c)  , -2023.
roamer55.ru
}


unit __es_bayes;

interface

uses
  Classes,
  Vcl.Grids,
  Vcl.CheckLst, //     - 
                //., , PropsValue_from_TCheckListBox(),
                //Obj_Recognize(), PropsValue_from_TCheckListBox_to_TSTrings()
  Forms,
  SysUtils;

//-----------------
Type
  //  
  TTrainMode   = (ES_tmAuto, ES_tmManual);
  //  
  TTrainResult = (trNo, trYes);
  //  
  TObjTrainResult = (otrNo, otrYes, otrConfused);
  // /   
  TTrainProcessExit = (tpeNone, tpeNormal, tpeUserAbort, tpeExitForLimit);
//-----------------
//-----------------
//
Type
  //       /   
  TES_Common_Event   = procedure (Sender: TObject) of object;
  //    ( )
  TES_Auto_Cycle_Before_Event  = procedure (Sender: TObject; CycleNum:integer) of object;
  //     ( )
  TES_Auto_Cycle_After_Event   = procedure (Sender: TObject; CycleNum:integer; TR:TTrainResult; TPE:TTrainProcessExit) of object;
  //    (     )
  TES_Auto_Cycle_Step_Before_Event  = procedure (Sender: TObject; CycleNum:integer; ObjTrainIndex:integer) of object;
  //    (     )
  TES_Auto_Cycle_Step_After_Event  = procedure (Sender: TObject; CycleNum:integer; ObjTrainIndex:integer; TOR:TObjTrainResult) of object;
//-----------------
//-----------------
Type
  // 
  TObjRec = record
              id:integer;
              Rating:integer;
              RatingNorm:integer;
              RatingPercent:real;
              YesTrain:boolean;
              //RatingList:string; //    
            end;
  // ()
  TPropRec = record
              id:integer;
              Yes:boolean
            end;
  // 
  TRules = array of array of integer;
//-----------------

type
  //:  
  TES_bayes = class(TComponent)
  private
    { Private declarations }

    // 
    fVersion         : string;
    //:   (true - )
    fYesInit:boolean;

    //**************************************************
    // 
    //---------------------------------
    // :   
    fInTraining : boolean;
    //   (  )
    fTrainAbort  : boolean;
    //   (  )
    fTrainMode  : TTrainMode;
    //  
    fTrainResult : TTrainResult;
    //   (  )
    fObjTrainResult : TObjTrainResult;
    // /   
    fTrainProcessExit : TTrainProcessExit;
    // -  
    //   (   )
    fTrainCycleMaxCount:integer;
    //   
    fTrainCycle:integer;
    //      
    fTrainStep:integer;
    //      
    fObjTrainCount:integer;
    //---------------------------------
    // ,    
    //    
    fObjTrain_J        : integer;
    //    fObjTrain_J
    fObjTrain_Rating   : integer;
    //---------------------------------
    //-----------------------------------
    //
    //    
    fBeforeTrain : TES_Common_Event;
    // /   
    fAfterTrain  : TES_Common_Event;
    //    ( )
    fBeforeCycle : TES_Auto_Cycle_Before_Event;
    //     ( )
    fAfterCycle  : TES_Auto_Cycle_After_Event;
    //    (     )
    fBeforeStep  : TES_Auto_Cycle_Step_Before_Event;
    //    (     )
    fAfterStep   : TES_Auto_Cycle_Step_After_Event;
    //-----------------------------------
    //**************************************************
    //**************************************************
    // :     ()
    //---------------------------------
    // ()  
    fObjList : array of TObjRec;
    //-  
    fObjCount:integer;
    //-        (%)
    fRatingRoundTo : integer;
    //---------------------------------
    //---------------------------------
    // ()  (),
    //  
    fPropList : array of TPropRec;
    //-  (),   
    fPropCount:integer;
    //---------------------------------
    //**************************************************
    //**************************************************
    //    
    //---------------------------------
    // ()   
    fRules : TRules;
    //---------------------------------
    // ()    
    fObjBest_J:integer;
    //     fObjBest_J
    fObjBest_Rating: integer;
    //---------------------------------
    //**************************************************

  protected
    { Protected declarations }

    //------------------------------------
    //,  (  )   
    procedure Arrays_NIL;
    function Arrays_Create:boolean;
    function ObjList_Create:boolean;
    function PropList_Create:boolean;
    function Rules_Create:boolean;
    procedure Arrays_Clear;
    procedure ObjList_Clear;
    procedure ObjList_Rating_Clear;
    procedure ObjList_YesTrain_Clear;
    procedure ObjList_TrainInfo_Clear;
    procedure PropList_Clear;
    procedure Rules_Clear;
    //------------------------------------

    //------------------------------------
    //      
    function ES_Train_Auto(PropsListTrue_for_EachObj:TStrings):boolean;
    //     (  )
    //    
    function Obj_Train_Auto(ListRat:TStrings):boolean;
    //------------------------------------
    //------------------------------------
    //     
    function ES_Train_Manual(PropsListTrue_for_EachObj:TStrings):boolean;
    //., , ES_Train_Manual_Next()
    //------------------------------------
    //------------------------------------
    //    
    function ES_Train_Exit_Normal:boolean;
    //------------------------------------
    //------------------------------------
    //     
    function Rules_Cell_Get(I, J : integer):integer;
    //     
    function Rules_Cell_Set(I, J, V : integer):boolean;

    //------------------------------------
    // Id    
    function Obj_Id_Get(J:integer):integer;
    // Id    
    function Obj_Id_Set(J:integer; V:integer):boolean;
    //------------------------------------
    //------------------------------------
    //     
    function Obj_Rating_Get(J:integer):integer;
    //     
    function Obj_Rating_Set(J:integer; V:integer):boolean;
    //      
    function Obj_RatingNorm_Get(J:integer):integer;
    //      
    function Obj_RatingNorm_Set(J:integer; V:integer):boolean;
    //   (%)   
    function Obj_RatingPercent_Get(J:integer):Real;
    //   (%)   
    function Obj_RatingPercent_Set(J:integer; V:Real):boolean;
    //------------------------------------
    //------------------------------------
    //  YesTrain    
    function Obj_YesTraing_Get(J:integer):boolean;
    //  YesTrain    
    function Obj_YesTraing_Set(J:integer; V:boolean):boolean;
    //------------------------------------
    //------------------------------------
    // Id  ()   
    function Prop_Id_Get(I:integer):integer;
    // Id  ()   
    function Prop_Id_Set(I:integer; V:integer):boolean;
    //------------------------------------
    //------------------------------------
    //   ()   
    function Prop_Yes_Get(I:integer):boolean;
    //   ()   
    function Prop_Yes_Set(I:integer; V:boolean):boolean;
    //------------------------------------

    //    
    function ObjList_Ratings_Calc:boolean;
    //    
    function Obj_Rating_Best_Find:boolean;
    // ?
    function ES_right:boolean;
    //:    ?
    function ES_Recognized_All_Objects:boolean;

    //     (    ),  
    function ObjList_Any_Rules_ReCalc:boolean;
    //    
    //function ObjTrain_Rating_ReCalc:boolean;
    function ObjBest_Rules_ReCalc:boolean;

    //   ()  TCheckListBox  TStrings
    function PropsValue_from_TCheckListBox_to_TSTrings(ListFrom:TCheckListBox; ListTo:TStrings):boolean;

  public
    { Public declarations }

    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;

    // 
    property Version : string read fVersion;

    //------------------------------------
    // ():   
    property ComponentInitOK : boolean read fYesInit;
    //------------------------------------

    //****************************************
    //  ( )
    //--------------------------
    //   (  )
    property TrainMode : TTrainMode read fTrainMode;
    // :   
    property InTraining : boolean read fInTraining;
    //   
    property TrainCycle : integer read fTrainCycle;
    //      
    property TrainStep : integer read fTrainStep;
    //  
    property TrainResult : TTrainResult read fTrainResult;
    //   (  )
    property ObjTrainResult : TObjTrainResult read fObjTrainResult;
    // /   
    property TrainProcessExit : TTrainProcessExit read fTrainProcessExit;
    //--------------------------
    //--------------------------
    //-  
    property ObjCount : integer read fObjCount;
    //-  (),   
    property PropCount : integer read fPropCount;
    //--------------------------
    //--------------------------
    // ,    
    //     
    property ObjTrain_J : integer read fObjTrain_J;
    //    fObjTrain_J
    property ObjTrain_Rating : integer read fObjTrain_Rating;
    //      
    property ObjTrainCount : integer read fObjTrainCount;
    //--------------------------
    //--------------------------
    // ()    
    property ObjBest_J : integer read fObjBest_J;
    //     fObjBest_J
    property ObjBest_Rating : integer read fObjBest_Rating;
    //--------------------------
    //****************************************

    //------------------------------------
    //  (    -   )
    function Obj_Recognize(ListProp:TStrings; ListFuzzi:TStrings=nil):integer; overload;
    function Obj_Recognize(ListProp:TCheckListBox; ListFuzzi:TStrings=nil):integer; overload;
    //------------------------------------
    //--------------------------
    //  (    )
    function Init(ObjCount:integer; PropCount:integer):boolean;
    //   
    function ES_Train_Start(ES_TrainMode:TTrainMode; PropsListTrue_for_EachObj:TStrings):boolean;
    //     (    ))   
    function ES_Train_Manual_Next(PropsListTrue_for_EachObj:TStrings):boolean;
    //     -   -  
    procedure ES_Train_ExitForLimit;
    //       
    procedure ES_Train_Exit_UserAbort;
    //--------------------------

    //--------------------------
    //    
    function Obj_Add(Id:integer):integer;
    //  ()    ()
    function Prop_Add(Id:integer; Yes:boolean=false):integer;
    //    TStrings
    function ObjList_LoadFromTStrings(List:TStrings):boolean;
    //   ()  TStrings
    function PropList_LoadFromTStrings(List:TStrings):boolean;
    //--------------------------

    //-----------------------------------------------
    //  ( 2- )  
    function Obj_Rating_TStringGrid_Clear(SG:TStringGrid) : boolean;
    //     
    function Obj_Rating_to_TStringGrid(SG:TStringGrid):boolean;
    //        -  
    function Obj_Rating_Percent_Recalc:boolean;
    //  ( 2- )    TStringGrid
    function Rules_TStringGrid_Clear(SG:TStringGrid) : boolean;
    //    TStringGrid
    function Rules_to_TStringGrid(SG:TStringGrid):boolean;
    //    TStringGrid
    function Rules_From_TStringGrid(SG:TStringGrid):boolean;
    //-----------------------------------------------

    //------------------------------------
    //   fObjTrain_J
    function ObjTrain_Set(ObjTrainJ:integer):boolean;
    //       (0-false, 1-true)
    function PropsValue_from_IntArray(ArrayProp:array of integer; ArraySize:integer):boolean;
    //    TStrings ('0'-false, '1'-true)
    function PropsValue_from_TStrings(ListProp:TStrings):boolean;
    //    TCheckListBox
    //     -  (., ,  Uses)
    function PropsValue_from_TCheckListBox(ListProp:TCheckListBox):boolean;
    //  ,   
    function PropValue_AsInteger(I:integer):integer;
    //,       = TRUE
    function PropsValue_Control:boolean;
    //------------------------------------

    //------------------------------------
    // TTrainMode  String (  Log)
    function TrainMode_to_Str(tm:TTrainMode; YesForUser:boolean=false):string;
    // TTrainResult  String (  Log)
    function TrainResult_to_Str(tr:TTrainResult; YesForUser:boolean=false):string;
    // TObjTrainResult  String (  Log)
    function ObjTrainResult_to_Str(tr:TObjTrainResult; YesForUser:boolean=false):string;
    // TTrainProcessExit  String (  Log)
    function TrainProcessExit_to_Str(tpe:TTrainProcessExit; YesForUser:boolean=false):string;
    //------------------------------------


  published
    { Published declarations }

    //******************************************
    //  (/)
    //------------------------------------
    // -  
    //   (   )
    property TrainCycleMaxCount:integer read fTrainCycleMaxCount write fTrainCycleMaxCount;
    //-        (%)
    property RatingRoundTo:integer read fRatingRoundTo write fRatingRoundTo;
    //------------------------------------
    //******************************************

    //******************************************
    //
    //------------------------------------
    //    
    property BeforeTrain : TES_Common_Event read fBeforeTrain write fBeforeTrain;
    // /   
    property AfterTrain  : TES_Common_Event read fAfterTrain write fAfterTrain;
    //    ( )
    property BeforeCycle : TES_Auto_Cycle_Before_Event read fBeforeCycle write fBeforeCycle;
    //     ( )
    property AfterCycle  : TES_Auto_Cycle_After_Event read fAfterCycle write fAfterCycle;
    //    (     )
    property BeforeStep : TES_Auto_Cycle_Step_Before_Event read fBeforeStep write fBeforeStep;
    //    (     )
    property AfterStep  : TES_Auto_Cycle_Step_After_Event read fAfterStep write fAfterStep;
    //------------------------------------
    //******************************************

  end;


procedure Register;

//     
function RoundTo(V:extended;iRoundTo:integer=2):extended;

implementation

Const
  //VersionX = '1.00 (12.09.2023)'; // 
  VersionX = '1.01 (20.09.2023)'; // 

procedure Register;
begin
  RegisterComponents('SP', [TES_bayes]);
end;

constructor TES_bayes.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);

  fVersion            := VersionX;

  //---------------------
  fYesInit            := false;
  fRatingRoundTo      := 3;
  //---------------------
  //---------------------
  fTrainMode          := ES_tmAuto;
  fTrainResult        := trNo;
  fObjTrainResult     := otrNo;
  fTrainProcessExit   := tpeNone;
  fTrainAbort         := false;
  fInTraining         := false;
  fTrainCycleMaxCount := 100;
  fTrainCycle         := 0;
  fTrainStep          := 0;
  //---------------------
  //---------------------
  fObjList  := nil;
  fObjCount := 0;
  fPropList  := nil;
  fPropCount := 0;
  fRules    := nil;
  //---------------------
end;


destructor TES_bayes.Destroy;
begin
  Arrays_NIL;
  inherited Destroy;
end;

procedure TES_bayes.Arrays_NIL;
begin
  fObjList:=nil;
  fObjCount := 0;
  fPropList:=nil;
  fPropCount := 0;
  fRules:=nil;
end;

//***********************************
function TES_bayes.ObjList_Create:boolean;
begin
  Result:=false;
  fObjList:=nil;
  if fObjCount>1 then begin
     SetLength(fObjList,fObjCount);
     ObjList_Clear;
     Result:=true;
  end;
end;
procedure TES_bayes.ObjList_Clear;
Var
  J:integer;
begin
  if fYesInit then begin
     for J:=0 to (fObjCount-1) do
      begin
        fObjList[J].id:=0;
        fObjList[J].Rating:=0;
        fObjList[J].RatingNorm:=0;
        fObjList[J].RatingPercent:=0.0;
        fObjList[J].YesTrain:=false;
        //fObjList[J].RatingList:='';
     end;
  end;
end;
procedure TES_bayes.ObjList_Rating_Clear;
//     
Var
  J:integer;
begin
  if fYesInit then begin
     for J:=0 to (fObjCount-1) do
      begin
        fObjList[J].Rating:=0;
        fObjList[J].RatingNorm:=0;
        fObjList[J].RatingPercent:=0.0;
        //fObjList[J].RatingList:='';
     end;
  end;
end;
procedure TES_bayes.ObjList_YesTrain_Clear;
//  YesTrain   
Var
  J:integer;
begin
  if fYesInit then begin
     for J:=0 to (fObjCount-1) do
      begin
        fObjList[J].YesTrain:=false;
     end;
  end;
end;
procedure TES_bayes.ObjList_TrainInfo_Clear;
//      YesTrain
//  
Var
  J:integer;
begin
  if fYesInit then begin
     for J:=0 to (fObjCount-1) do
      begin
        fObjList[J].Rating:=0;
        fObjList[J].RatingNorm:=0;
        fObjList[J].RatingPercent:=0.0;
        fObjList[J].YesTrain:=false;
        //fObjList[J].RatingList:='';
     end;
  end;
end;
function TES_bayes.PropList_Create:boolean;
begin
  Result:=false;
  fPropList:=nil;
  if fPropCount>1 then begin
     SetLength(fPropList,fPropCount);
     PropList_Clear;
     Result:=true;
  end;
end;
procedure TES_bayes.PropList_Clear;
Var
  I:integer;
begin
  if fPropList<>nil then begin
    if Length(fPropList)=fPropCount then begin
       for I:=0 to (fPropCount-1) do
        begin
          fPropList[I].id:=0;
          fPropList[I].Yes:=false;
       end;
    end;
  end;
end;
function TES_bayes.Rules_Create:boolean;
begin
  Result:=false;
  fRules:=nil;
  if (fPropCount>1) and (fObjCount>1) then begin
     SetLength(fRules,fPropCount, fObjCount);
     Rules_Clear;
     Result:=true;
  end;
end;
procedure TES_bayes.Rules_Clear;
Var
  I, J : integer;
begin
  if fRules<>nil then begin
     if (fPropCount>1) and (fObjCount>1) then begin
        for I:=0 to (fPropCount-1) do
         begin
           for J:=0 to (fObjCount-1) do
            begin
              fRules[I,J]:=0;
           end;
        end;
     end;
  end;
end;
function TES_bayes.Arrays_Create:boolean;
begin
  Result:=false;
  if ObjList_Create then begin
     if PropList_Create then begin
        Result:=Rules_Create;
     end;
  end;
end;
procedure TES_bayes.Arrays_Clear;
begin
  ObjList_Clear;
  PropList_Clear;
  Rules_Clear;
end;
//***********************************

function TES_bayes.Init(ObjCount:integer; PropCount:integer):boolean;
//  (    )
begin
  Result:=false;
  fYesInit := false;
  if not fInTraining then begin
     Arrays_NIL;
     if fTrainCycleMaxCount>=10 then begin
        if (PropCount>1) and  (ObjCount>1) then begin
           //-------------------------
           fTrainProcessExit   := tpeNone;
           fInTraining         := false;
           fTrainCycle         := 0;
           fTrainStep          := 0;
           fTrainAbort         := false;
           fTrainResult        := trNo;
           fObjTrainResult     := otrNo;
           //-------------------------
           //-------------------------
           fObjTrain_J      := -1;
           fObjTrain_Rating := 0;
           //-------------------------
           //-------------------------
           fObjBest_J       := -1;
           fObjBest_Rating     := 0;
           //-------------------------
           //-------------------------
           fPropCount:=PropCount;
           fObjCount:=ObjCount;
           //-------------------------
           //-------------------------
           fYesInit:=Arrays_Create;
           //-------------------------
           Result:=fYesInit;
        end;
     end;
  end;
end;

function TES_bayes.ES_Train_Start(ES_TrainMode:TTrainMode; PropsListTrue_for_EachObj:TStrings):boolean;
//   
Var
 YesNext:boolean;
begin
  Result:=false;
  YesNext:=false;
  if not fInTraining then begin
     if fYesInit then begin
        if Assigned(PropsListTrue_for_EachObj) then begin
           if PropsListTrue_for_EachObj.Count>1 then begin
              YesNext:=true;
           end;
        end;
     end;
  end;
  if YesNext then begin
     //-------------------------
     fTrainMode          := ES_TrainMode;
     fTrainProcessExit   := tpeNone;
     fInTraining         := true;
     fTrainCycle         := 1;
     fTrainStep          := 0;
     fTrainAbort         := false;
     fTrainResult        := trNo;
     fObjTrainResult     := otrNo;
     //-------------------------
     //-------------------------
     fObjTrain_J      := -1;
     fObjTrain_Rating := 0;
     //-------------------------
     //-------------------------
     fObjBest_J       := -1;
     fObjBest_Rating     := 0;
     //-------------------------
     //-------------------------
     //  
     Rules_Clear;
     //-------------------------
     //-------------------------
     if fTrainMode=ES_tmAuto then begin
        //    
        Result:=ES_Train_Auto(PropsListTrue_for_EachObj);
        fInTraining := false;
     end
     else begin
        //     
        Result:=ES_Train_Manual(PropsListTrue_for_EachObj);
     end;
     //-------------------------
  end;
end;


function TES_bayes.ES_Train_Auto(PropsListTrue_for_EachObj:TStrings):boolean;
//      
Var
  J,I,v:integer;
  sName,S:string;
  YesExit:boolean;
  ListRating:TStrings;
begin
  Result:=false;
  if fInTraining then begin
     if Assigned(PropsListTrue_for_EachObj) then begin
        if PropsListTrue_for_EachObj.Count>0 then begin
           ListRating:=TStringList.Create;
           TRY
              fTrainCycle  := 0;
              fTrainStep   := 0;
              fObjTrainCount:= 0;

              if Assigned(fBeforeTrain) then fBeforeTrain(Self);

              YesExit:=false;
              while not YesExit do
               begin
                fTrainCycle := fTrainCycle + 1;
                fTrainStep  := 0;
                ListRating.Clear;

                if Assigned(fBeforeCycle) then fBeforeCycle(Self, fTrainCycle);

                J:=-1;
                while J<(fObjCount-1) do
                 begin
                  J := J + 1;
                  fTrainStep  := fTrainStep + 1;

                  //------------------------------------
                  fObjTrain_J := J;
                  fObjTrain_Rating := 0;
                  fObjBest_J       := -1;
                  fObjBest_Rating  := 0;
                  ListRating.Clear;
                  //------------------------------------

                  //------------------------------------
                  fObjList[fObjTrain_J].Rating:=0;
                  fObjList[fObjTrain_J].RatingNorm:=0;
                  fObjList[fObjTrain_J].RatingPercent:=0;
                  fObjList[fObjTrain_J].YesTrain:=false;
                  //fObjList[fObjTrain_J].RatingList:='';
                  //------------------------------------

                  if Assigned(fBeforeStep) then fBeforeStep(Self, fTrainCycle, fObjTrain_J);

                  //------------------------------------
                  //  TRUE    ,     fObjTrain_J
                  for I:=0 to (fPropCount-1) do
                   begin
                     fPropList[I].Yes:=false;
                     sName:=IntToStr(fObjTrain_J)+'_'+IntToStr(I);
                     S:=trim(PropsListTrue_for_EachObj.Values[sName]);
                     v:=StrToIntDef(S,0);
                     if v>0 then fPropList[I].Yes:=true;
                  end;
                  //------------------------------------

                  //------------------------------------
                  if Obj_Train_Auto(ListRating)  then begin
                     fObjList[fObjTrain_J].YesTrain:=true;
                     fObjTrainCount := fObjTrainCount + 1;
                     if fObjTrainCount>=fObjCount then begin
                        //YesExit:=true;
                        fTrainResult := trYes;   // 
                     end;
                  end
                  else begin
                     fObjList[fObjTrain_J].YesTrain:=false;
                     fObjTrainCount := fObjTrainCount - 1;
                     fTrainResult        := trNo; //???
                  end;
                  //------------------------------------

                  if Assigned(fAfterStep) then fAfterStep(Self, fTrainCycle, fObjTrain_J, fObjTrainResult);

                  Application.ProcessMessages;
                end;

                //-------------------
                //fObjList[fObjTrain_J].RatingList:=ListRating.Text;
                //-------------------

                if fTrainAbort then begin
                   //  
                   fTrainProcessExit   := tpeUserAbort;
                   fTrainResult        := trNo;
                   YesExit             := true;
                end
                else begin
                   if fTrainCycle>=fTrainCycleMaxCount then begin
                      //    
                      fTrainProcessExit   := tpeExitForLimit;
                      fTrainResult        := trNo;
                      YesExit             := true;
                   end
                   else begin
                      if fTrainResult = trYes then begin
                         Result:=true;
                         YesExit := true;
                         fTrainProcessExit   := tpeNormal;
                      end;
                   end;
                end;

                if Assigned(fAfterCycle) then fAfterCycle(Self, fTrainCycle, fTrainResult, fTrainProcessExit);

                Application.ProcessMessages;
              end;

              if Assigned(fAfterTrain) then fAfterTrain(Self);

           FINALLY
             FreeAndNil(ListRating);
           END;
        end;
     end;
  end;
end;


function TES_bayes.ES_Train_Manual(PropsListTrue_for_EachObj:TStrings):boolean;
//     
Var
  J,I,v:integer;
  sName,S:string;
begin
  Result:=false;
  if fInTraining then begin
     if Assigned(PropsListTrue_for_EachObj) then begin
        if PropsListTrue_for_EachObj.Count>0 then begin
           Result:=true;
           //------------------------------------
           fTrainCycle  := 1;
           fTrainStep   := 0;
           fObjTrainCount:= 0;
           //------------------------------------
           //------------------------------------
           fObjTrain_J := -1;
           fObjTrain_Rating := 0;
           fObjBest_J       := -1;
           fObjBest_Rating     := 0;
           //------------------------------------
        end;
     end;
  end;
end;

function TES_bayes.ES_Train_Manual_Next(PropsListTrue_for_EachObj:TStrings):boolean;
//     (    ))   
Var
  I,v:integer;
  sName,S:string;
  ListRat:TStrings;
begin
  Result:=false;
  if fInTraining then begin
     if Assigned(PropsListTrue_for_EachObj) then begin
        if PropsListTrue_for_EachObj.Count>0 then begin
           Result:=true;
           ListRat:=TStringList.Create;
           TRY
             //------------------------------------
             fTrainStep  := fTrainStep + 1;
             fObjTrain_J := fObjTrain_J+1;
             if fObjTrain_J>=fObjCount then begin
                fTrainCycle  := fTrainCycle+1;
                fTrainStep   := 1;
                fObjTrain_J  := 0;
             end;
             //------------------------------------
             //------------------------------------
             fObjTrain_Rating := 0;
             fObjBest_J       := -1;
             fObjBest_Rating     := 0;
             ListRat.Clear;
             //------------------------------------
             //------------------------------------
             fObjList[fObjTrain_J].Rating:=0;
             fObjList[fObjTrain_J].RatingNorm:=0;
             fObjList[fObjTrain_J].RatingPercent:=0;
             fObjList[fObjTrain_J].YesTrain:=false;
             //fObjList[fObjTrain_J].RatingList:='';
             //------------------------------------
             //------------------------------------
             //  TRUE    ,
             //    fObjTrain_J
             for I:=0 to (fPropCount-1) do
              begin
                fPropList[I].Yes:=false;
                sName:=IntToStr(fObjTrain_J)+'_'+IntToStr(I);
                S:=trim(PropsListTrue_for_EachObj.Values[sName]);
                v:=StrToIntDef(S,0);
                if v>0 then fPropList[I].Yes:=true;
             end;
             //------------------------------------
             //------------------------------------
             if Obj_Train_Auto(ListRat)  then begin
                fObjList[fObjTrain_J].YesTrain:=true;
                fObjTrainCount := fObjTrainCount + 1;
                if fObjTrainCount>=fObjCount then begin
                   fTrainResult := trYes;   // 
                end;
             end
             else begin
                fObjList[fObjTrain_J].YesTrain:=false;
                fObjTrainCount := fObjTrainCount - 1;
                fTrainResult        := trNo; //???
             end;
             //------------------------------------
           FINALLY
              FreeAndNil(ListRat);
           END;
        end;
     end;
  end;
end;

function TES_bayes.Obj_Train_Auto(ListRat:TStrings):boolean;
//     (  )     
Var
  YesNext:boolean;
  I,J,v,r,d:integer;
begin
  Result:=false;
  fObjTrainResult := otrNo;
  YesNext:=false;
  if Assigned(ListRat) then begin
     ListRat.Clear;
     if fInTraining then begin
        if fObjTrain_J>=0 then begin
           YesNext:=true;
        end;
     end;
  end;
  if YesNext then begin
     //------------------------------------
     // ()  
     ObjList_Rating_Clear;
     //------------------------------------
     //------------------------------------
     //  
     ObjList_Ratings_Calc;
     //------------------------------------
     //------------------------------------
     //    
     Obj_Rating_Best_Find;
     //------------------------------------
     //------------------------------------
     //
     if fObjBest_J <> fObjTrain_J then begin
        // 
        fObjTrainResult     := otrNo;
        fobjBest_J:=fObjTrain_J;
        fObjBest_Rating:=fObjList[fobjBest_J].Rating;
     end
     else begin
        if fObjBest_Rating>0 then begin
           // 
           Result:=true;
           fObjTrainResult     := otrYes;
        end
        else begin
           // 
          fObjTrainResult     := otrConfused;
          fobjBest_J:=fObjTrain_J;
          fObjBest_Rating:=fObjList[fobjBest_J].Rating;
        end;
     end;
     //------------------------------------
     //------------------------------------
     //    ,
     //    
     ObjList_Any_Rules_ReCalc;
     //------------------------------------
     //------------------------------------
     //      
     ObjBest_Rules_ReCalc;
     //------------------------------------
     //------------------------------------
     //  
     Obj_Rating_Percent_Recalc;
     //------------------------------------
  end;
end;

function TES_bayes.Rules_Cell_Get(I, J : integer):integer;
//     
begin
  Result:=-999999999;
  if fRules<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        if (I>=0) and (I<=(fPropCount-1))  then begin
           Result:=fRules[I,J];
        end;
     end;
  end;
end;


function TES_bayes.Rules_Cell_Set(I, J, V : integer):boolean;
//     
begin
  Result:=false;
  if fRules<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        if (I>=0) and (I<=(fPropCount-1))  then begin
           fRules[I,J]:=V;
           Result:=true;
        end;
     end;
  end;
end;


function TES_bayes.ES_Train_Exit_Normal:boolean;
//    
//..,  
begin
  Result:=false;
  if fInTraining then begin
     //if fTrainResult = trYes then Result:=true;
     Result              := true;
     fTrainResult        := trYes;
     fTrainProcessExit   := tpeNormal;
     fInTraining         := false;
     fTrainAbort         := false;
  end;
end;


procedure TES_bayes.ES_Train_Exit_UserAbort;
// ()      
begin
  if fInTraining then begin
     fInTraining         := false;
     fTrainAbort         := true;
     if (fTrainMode = ES_tmAuto) then fTrainResult := trNo;
     fTrainProcessExit   := tpeUserAbort;
  end;
end;

procedure TES_bayes.ES_Train_ExitForLimit;
// ()    -     
begin
  if fInTraining then begin
     fInTraining         := false;
     fTrainAbort         := false;
     fTrainResult        := trNo;
     fTrainProcessExit   := tpeExitForLimit;
  end;
end;


function TES_bayes.Obj_Id_Get(J:integer):integer;
// Id    
begin
  Result:=0;
  if fObjList<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        Result:=fObjList[J].Id;
     end;
  end;
end;

function TES_bayes.Obj_Id_Set(J:integer; V:integer):boolean;
// Id    
begin
  Result:=false;
  if fObjList<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        if V>0 then begin
           fObjList[J].Id:=V;
           Result:=true;
        end;
     end;
  end;
end;


function TES_bayes.Obj_Rating_Get(J:integer):integer;
//     
begin
  Result:=0;
  if fObjList<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        Result:=fObjList[J].Rating;
     end;
  end;
end;

function TES_bayes.Obj_Rating_Set(J:integer; V:integer):boolean;
//     
begin
  Result:=false;
  if fObjList<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        fObjList[J].Rating:=V;
        Result:=true;
     end;
  end;
end;

function TES_bayes.Obj_RatingNorm_Get(J:integer):integer;
//      
begin
  Result:=0;
  if fObjList<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        Result:=fObjList[J].RatingNorm;
     end;
  end;
end;

function TES_bayes.Obj_RatingNorm_Set(J:integer; V:integer):boolean;
//      
begin
  Result:=false;
  if fObjList<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        fObjList[J].RatingNorm:=V;
        Result:=true;
     end;
  end;
end;

function TES_bayes.Obj_RatingPercent_Get(J:integer):Real;
//   (%)   
begin
  Result:=0;
  if fObjList<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        Result:=fObjList[J].RatingPercent;
     end;
  end;
end;

function TES_bayes.Obj_RatingPercent_Set(J:integer; V:Real):boolean;
//   (%)   
begin
  Result:=false;
  if fObjList<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        fObjList[J].RatingPercent:=V;
        Result:=true;
     end;
  end;
end;


function TES_bayes.Obj_YesTraing_Get(J:integer):boolean;
//  YesTrain    
begin
  Result:=false;
  if fObjList<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        Result:=fObjList[J].YesTrain;
     end;
  end;
end;

function TES_bayes.Obj_YesTraing_Set(J:integer; V:boolean):boolean;
//  YesTrain    
begin
  Result:=false;
  if fObjList<>nil then begin
     if (J>=0) and (J<=(fObjCount-1))  then begin
        fObjList[J].YesTrain:=V;
        Result:=true;
     end;
  end;
end;


function TES_bayes.Prop_Yes_Get(I:integer):boolean;
//   ()   
begin
  Result:=false;
  if fPropList<>nil then begin
     if (I>=0) and (I<=(fPropCount-1))  then begin
        Result:=fPropList[I].Yes;
     end;
  end;
end;

function TES_bayes.Prop_Yes_Set(I:integer; V:boolean):boolean;
//   ()   
begin
  Result:=false;
  if fPropList<>nil then begin
     if (I>=0) and (I<=(fPropCount-1))  then begin
        fPropList[I].Yes:=V;
        Result:=true;
     end;
  end;
end;

function TES_bayes.Prop_Id_Get(I:integer):integer;
// Id  ()   
begin
  Result:=0;
  if fPropList<>nil then begin
     if (I>=0) and (I<=(fPropCount-1))  then begin
        Result:=fPropList[I].Id;
     end;
  end;
end;

function TES_bayes.Prop_Id_Set(I:integer; V:integer):boolean;
// Id  ()   
begin
  Result:=false;
  if fPropList<>nil then begin
     if (I>=0) and (I<=(fPropCount-1))  then begin
        if V>0 then begin
           fPropList[I].Id:=V;
           Result:=true;
        end;
     end;
  end;
end;

function TES_bayes.Obj_Add(Id:integer):integer;
// .  :  J  (  )
Var
  J:integer;
begin
  Result:=-1;
  if fObjList<>nil then begin
     if Id>0 then begin
        J:=-1;
        while J<(fObjCount-1) do
         begin
          J:=J+1;
          if fObjList[J].id<=0 then begin
             Result:=J;
             fObjList[J].id:=Id;
             fObjList[J].Rating:=0;
             fObjList[J].RatingNorm:=0;
             fObjList[J].RatingPercent:=0;
             fObjList[J].YesTrain:=false;
             //fObjList[J].RatingList:='';
             J:=(fObjCount+1);
          end;
        end;
     end;
  end;
end;

function TES_bayes.Prop_Add(Id:integer; Yes:boolean=false):integer;
// .  :  I   (  )
Var
  I:integer;
begin
  Result:=-1;
  if fPropList<>nil then begin
     if Id>0 then begin
        I:=-1;
        while I<(fPropCount-1) do
         begin
          I:=I+1;
          if fPropList[I].id<=0 then begin
             Result:=I;
             fPropList[I].id:=Id;
             fPropList[I].Yes:=Yes;
             I:=(fPropCount+1);
          end;
        end;
     end;
  end;
end;


function TES_bayes.ObjList_LoadFromTStrings(List:TStrings):boolean;
//   TStrings
// List:
// id=;
Var
  J:integer;
  Id:integer;
begin
  Result:=false;
  if fObjList<>nil then begin
     if Assigned(List) then begin
        if List.Count=fObjCount then begin
           Result:=true;
           J:=-1;
           while J<(List.Count-1) do
            begin
             J:=J+1;
             Id:=StrToIntDef(trim(List.Names[J]),0);
             if Id>0 then begin
                if Obj_Add(Id)<0 then begin
                   Result:=false;
                   J:=(List.Count+1);
                end;
             end
             else begin
                Result:=false;
                J:=(List.Count+1);
             end;
           end;
        end;
     end;
  end;
end;

function TES_bayes.PropList_LoadFromTStrings(List:TStrings):boolean;
//   TStrings
// List:
// id=01;
Var
  I:integer;
  Id:integer;
  N:integer;
  Yes:boolean;
begin
  Result:=false;
  if fPropList<>nil then begin
     if Assigned(List) then begin
        if List.Count=fPropCount then begin
           Result:=true;
           I:=-1;
           while I<(List.Count-1) do
            begin
             I:=I+1;
             Id:=StrToIntDef(trim(List.Names[I]),0);
             if Id>0 then begin
                N:=StrToIntDef(trim(List.Values[trim(List.Names[I])]),0);
                Yes:=false;
                if N>0 then Yes:=true;
                if Prop_Add(Id, Yes)<0 then begin
                   Result:=false;
                   I:=(List.Count+1);
                end;
             end
             else begin
                Result:=false;
                I:=(List.Count+1);
             end;
           end;
        end;
     end;
  end;
end;


//**************************************
function TES_bayes.TrainMode_to_Str(tm:TTrainMode; YesForUser:boolean=false):string;
// TTrainMode  String (  Log)
begin
  Result:='???';
  if not YesForUser then begin
     if tm=ES_tmAuto then Result:='ES_tmAuto';
     if tm=ES_tmManual then Result:='ES_tmManual';
  end
  else begin
     if tm=ES_tmAuto then Result:='';
     if tm=ES_tmManual then Result:='';
  end;
end;
function TES_bayes.TrainResult_to_Str(tr:TTrainResult; YesForUser:boolean=false):string;
// TTrainResult  String (  Log)
begin
  Result:='???';
  if not YesForUser then begin
     if tr=trNo then Result:='trNo';
     if tr=trYes then Result:='trYes';
  end
  else begin
     if tr=trNo then Result:='  ';
     if tr=trYes then Result:=' ';
  end;
end;
function TES_bayes.ObjTrainResult_to_Str(tr:TObjTrainResult; YesForUser:boolean=false):string;
// TObjTrainResult  String (  Log)
begin
  Result:='???';
  if not YesForUser then begin
     if tr=otrNo then Result:='otrNo';
     if tr=otrYes then Result:='otrYes';
     if tr=otrConfused then Result:='otrConfused';
  end
  else begin
     if tr=otrNo then Result:='';
     if tr=otrYes then Result:='';
     if tr=otrConfused then Result:=' ';
  end;
end;
function TES_bayes.TrainProcessExit_to_Str(tpe:TTrainProcessExit; YesForUser:boolean=false):string;
// TTrainProcessExit  String (  Log)
begin
  Result:='???';
  if not YesForUser then begin
     if tpe=tpeNone then Result:='tpeNone';
     if tpe=tpeNormal then Result:='tpeNormal';
     if tpe=tpeUserAbort then Result:='tpeUserAbort';
     if tpe=tpeExitForLimit then Result:='tpeExitForLimit';
  end
  else begin
     if tpe=tpeNone then Result:=' ';
     if tpe=tpeNormal then Result:=' ';
     if tpe=tpeUserAbort then Result:='  ';
     if tpe=tpeExitForLimit then Result:='  ';
  end;
end;
//**************************************

function TES_bayes.Obj_Rating_TStringGrid_Clear(SG:TStringGrid) : boolean;
//  ( 2- )  
begin
  Result:=false;
  if Assigned(SG) then begin
     //SG.ColCount:=7;
     SG.ColCount:=6;
     SG.RowCount:=2;
     SG.Rows[0].Clear;
     SG.Rows[1].Clear;
     SG.Cells[0,0]:='J';
     SG.Cells[1,0]:='';
     SG.Cells[2,0]:='';
     SG.Cells[3,0]:='()';
     SG.Cells[4,0]:=',%';
     SG.Cells[5,0]:='id';
     Result:=true;
  end;
end;

function TES_bayes.Obj_Rating_to_TStringGrid(SG:TStringGrid):boolean;
//    TStringGrid
Var
  J:integer;
begin
  Result:=false;
  if Assigned(SG) then begin
     Obj_Rating_TStringGrid_Clear(SG);
     if fObjList<>nil then begin
        if fObjCount>1 then begin
           Result:=true;
           Obj_Rating_Percent_Recalc;
           J:=-1;
           while J<(fObjCount-1) do
            begin
             J:=J+1;
             if J>0 then begin
                SG.RowCount:=SG.RowCount+1;
             end;
             SG.Cells[0,SG.RowCount-1]:=IntToStr(J+1);
             //SG.Cells[1,SG.RowCount-1]:='';  //...
             SG.Cells[2,SG.RowCount-1]:=IntToStr(fObjList[J].Rating);
             SG.Cells[3,SG.RowCount-1]:=IntToStr(fObjList[J].RatingNorm);
             SG.Cells[4,SG.RowCount-1]:=FloatToStr(fObjList[J].RatingPercent);
             SG.Cells[5,SG.RowCount-1]:=IntToStr(fObjList[J].id);
           end;
        end;
     end;
  end;
end;

function TES_bayes.Obj_Rating_Percent_Recalc:boolean;
//        -  
Var
  J:integer;
  vMin, vNorm, vSum, v : integer;
  Rat,vW:real;
begin
  Result:=false;
  if fYesInit then begin
     Result:=true;
     if fRatingRoundTo<0 then fRatingRoundTo:=0;
     if fRatingRoundTo>5 then fRatingRoundTo:=5;
     vMin:=999999999;
     vSum:=0;
     for J:=0 to (fObjCount-1) do
      begin
       v:=fObjList[J].Rating;
       if vMin>v then vMin:=v;
     end;
     for J:=0 to (fObjCount-1) do
      begin
       v:=fObjList[J].Rating;
       vNorm:=v-vMin;
       vSum:=vSum+vNorm;
       fObjList[J].RatingNorm:=vNorm;
     end;
     for J:=0 to (fObjCount-1) do
      begin
       v:=fObjList[J].RatingNorm;
       vW:=v;
       if vSum<>0 then vW:=(v/vSum)*100;
       Rat:=RoundTo(vW,fRatingRoundTo);
       fObjList[J].RatingPercent:=Rat;
     end;
  end;
end;

function TES_bayes.Rules_TStringGrid_Clear(SG:TStringGrid) : boolean;
//  ( 2- )    TStringGrid
begin
  Result:=false;
  if Assigned(SG) then begin
     SG.ColCount:=2;
     SG.RowCount:=2;
     SG.Rows[0].Clear;
     SG.Rows[1].Clear;
     SG.Cells[1,1]:='0';
     SG.Cells[0,0]:=' i \ j ';
     Result:=true;
  end;
end;

function TES_bayes.Rules_From_TStringGrid(SG:TStringGrid):boolean;
//    TStringGrid
Var
  I,J, v:integer;
  S:string;
begin
  Result:=false;
  if fYesInit then begin
     if Assigned(SG) then begin
        for I:=1 to (SG.RowCount-1) do
         begin
           for J:=1 to (SG.ColCount-1) do
            begin
              v:=StrToIntDef(SG.Cells[J,I],0);
              fRules[I-1,J-1]:=v;
           end;
        end;
     end;
  end;
end;

function TES_bayes.Rules_to_TStringGrid(SG:TStringGrid):boolean;
//    TStringGrid
Var
  I, J, Row, Col : integer;
begin
  Result:=false;
  if Assigned(SG) then begin
     Rules_TStringGrid_Clear(SG);
     if fRules<>nil then begin
        if (fPropCount>1) and (fObjCount>1) then begin
           Result:=false;
           SG.ColCount:=fObjCount+1;
           SG.RowCount:=fPropCount+1;
           for Row:=1 to (SG.RowCount-1) do
            begin
             SG.Rows[Row].Clear;
             SG.Cells[0, Row]:=IntToStr(Row);
           end;
           for Col:=1 to (SG.ColCount-1) do
            begin
             SG.Cells[Col, 0]:=IntToStr(Col);
           end;
           Row:=0;
           for I:=0 to (fPropCount-1) do
            begin
              Row:=Row+1;
              //SG.Rows[Row].Clear;
              Col:=0;
              for J:=0 to (fObjCount-1) do
               begin
                Col:=Col+1;
                SG.Cells[Col, Row]:=IntToStr(fRules[I,J]);
              end;
           end;
        end;
     end;
  end;
end;

function TES_bayes.PropsValue_from_TCheckListBox_to_TSTrings(ListFrom:TCheckListBox; ListTo:TStrings):boolean;
//   ()  TCheckListBox  TStrings
Var
  I,v:integer;
begin
  Result:=false;
  if Assigned(ListTo) then begin
     ListTo.Clear;
     for I:=0 to (ListFrom.Items.Count-1) do
      begin
       v:=0;
       if ListFrom.Checked[I] then v:=1;
       ListTo.Add(IntToStr(v));
     end;
     if ListTo.Count>1 then Result:=true;
  end;
end;

function TES_bayes.PropsValue_from_IntArray(ArrayProp:array of integer; ArraySize:integer):boolean;
//       (0-false, 1-true)
Var
  I:integer;
begin
  Result:=false;
  if fYesInit then begin
     if ArraySize=fPropCount then begin
        Result:=true;
        for I:=0 to (fPropCount-1) do
         begin
          if ArrayProp[I]<=0 then begin
             fPropList[I].Yes:=false;
          end
          else begin
             fPropList[I].Yes:=true;
          end;
        end;
     end;
  end;
end;

function TES_bayes.PropsValue_from_TStrings(ListProp:TStrings):boolean;
//    TStrings ('0'-false, '1'-true)
Var
  I,v:integer;
begin
  Result:=false;
  if fYesInit then begin
     if Assigned(ListProp) then begin
        if ListProp.Count=fPropCount then begin
           Result:=true;
           for I:=0 to (fPropCount-1) do
            begin
              v:=StrToIntDef(trim(ListProp[I]),0);
              if v<=0 then begin
                 fPropList[I].Yes:=false;
              end
              else begin
                 fPropList[I].Yes:=true;
              end;
           end;
        end;
     end;
  end;
end;

function TES_bayes.PropsValue_from_TCheckListBox(ListProp:TCheckListBox):boolean;
//    TCheckListBox
//     -  (., ,  Uses)
Var
  I:integer;
begin
  Result:=false;
  if fYesInit then begin
     if Assigned(ListProp) then begin
        if ListProp.Items.Count=fPropCount then begin
           Result:=true;
           for I:=0 to (fPropCount-1) do
            begin
              fPropList[I].Yes:=ListProp.Checked[I];
           end;
        end;
     end;
  end;
end;

function TES_bayes.PropsValue_Control:boolean;
//,       = TRUE
Var
  I:integer;
begin
  Result:=false;
  if fYesInit then begin
     I:=-1;
     while I<(fPropCount-1) do
      begin
        I:=I+1;
        if fPropList[I].Yes then begin
           Result:=true;
           I:=(fPropCount+1);
        end;
     end;
  end;
end;

function TES_bayes.PropValue_AsInteger(I:integer):integer;
//  ,   
begin
  //Result:=-1;
  Result:=0;
  if fYesInit then begin
     if (I>=0) and (I<fPropCount) then begin
        if fPropList[I].Yes then begin
           Result:=1;
        end
        else begin
           Result:=0;
        end;
     end;
  end;
end;


function TES_bayes.ObjTrain_Set(ObjTrainJ:integer):boolean;
//   fObjTrain_J
begin
  Result:=false;
  fObjTrain_J:=-1;
  fObjTrain_Rating:=0;
  if fYesInit then begin
     if fInTraining then begin
        if (ObjTrainJ>=0) and (ObjTrainJ<fObjCount) then begin
           Result:=true;
           fObjTrain_J:=ObjTrainJ;
        end;
     end;
  end;
end;

function TES_bayes.ObjList_Ratings_Calc:boolean;
//     
Var
  I,J:integer;
  v,d,r:integer;
begin
  Result:=false;
  if fYesInit then begin
     Result:=true;
     for I:=0 to (fPropCount-1) do
      begin
       v:=PropValue_AsInteger(I);
       for J:=0 to (fObjCount-1) do
        begin
         d := fObjList[J].Rating;
         r := fRules[I,J];
         d := d + v*r;
         fObjList[J].Rating := d;
       end;
     end;
  end;
end;

function TES_bayes.Obj_Rating_Best_Find:boolean;
//    
Var
  J:integer;
begin
  Result:=false;
  fObjBest_J := -999999999;
  fObjBest_Rating := -999999999;
  if fYesInit then begin
     for J:=0 to (fObjCount-1) do
      begin
       if fObjList[J].Rating>fObjBest_Rating then begin
          fObjBest_Rating:=fObjList[J].Rating;
          fObjBest_J:=J;
       end;
     end;

     if fObjBest_J>=0 then begin
        Result:=true;
     end;
  end;
end;

function TES_bayes.ES_right:boolean;
//  ?
begin
  Result:=false;
  if fInTraining then begin
     if fObjTrain_J>=0 then begin
        if fObjBest_J = fObjTrain_J then begin
           if fObjBest_Rating>0 then begin
              Result:=true;
           end;
        end;
        fObjList[fObjTrain_J].YesTrain:=Result;
     end;
  end;
end;

function TES_bayes.ES_Recognized_All_Objects:boolean;
//:    ?
Var
  J:integer;
begin
  Result:=false;
  if fInTraining then begin
     Result:=true;
     J:=-1;
     while J<(fObjCount-1) do
      begin
       J:=J+1;
       if not fObjList[J].YesTrain then begin
          Result:=false;
          J:=(fObjCount+1);
       end;
     end;
  end;
end;

function TES_bayes.ObjList_Any_Rules_ReCalc:boolean;
//     (    ),  
Var
  I,J:integer;
  v,d,r:integer;
begin
  Result:=false;
  if fInTraining then begin
     if fObjTrain_J>=0 then begin
        Result:=true;
        for J:=0 to (fObjCount-1) do
         begin
          d := fObjList[J].Rating;
          if (d>=fObjBest_Rating) and (J<>fObjBest_J) then begin
             for I:=0 to (fPropCount-1) do
              begin
               v:=PropValue_AsInteger(I);
               r := fRules[I,J];
               r := r - v;
               fRules[I,J]:=r;
             end;
          end;
        end;
     end;
  end;
end;


function TES_bayes.ObjBest_Rules_ReCalc:boolean;
//     fObjBest_J
//(   -  fObjTrain_J)
Var
  I,J:integer;
  v,d,r:integer;
begin
  Result:=false;
  if fInTraining then begin
     if fObjBest_J>=0 then begin
        Result:=true;
        for I:=0 to (fPropCount-1) do
         begin
          v:=PropValue_AsInteger(I);
          r := fRules[I,fObjBest_J];
          r := r + v;
          fRules[I,fObjBest_J]:=r;
        end;
     end;
  end;
end;


//****************************
//****************************
//****************************
function TES_bayes.Obj_Recognize(ListProp:TCheckListBox; ListFuzzi:TStrings=nil):integer;
//  (    -   )
Var
  J :integer;
  YesNext:boolean;
  ListPropBuf:TStrings;
begin
  Result:=-1;
  if Assigned(ListFuzzi) then ListFuzzi.Clear;
  YesNext:=false;
  if fRules<>nil then begin
     if fObjList<>nil then begin
        if fPropList<>nil then begin
           if (fPropCount>1) and (fObjCount>1) then begin
              if Assigned(ListProp) then begin
                 if ListProp.Items.Count=fPropCount then begin
                    YesNext:=true;
                 end;
              end;
           end;
        end;
     end;
  end;
  if YesNext then begin
     ListPropBuf:=TStringList.Create;
     TRY
       //-------------------
       //   ()  TCheckListBox  TStrings
       PropsValue_from_TCheckListBox_to_TSTrings(ListProp, ListPropBuf);
       //-------------------
       //-------------------
       //   
       Result:=Obj_Recognize(ListPropBuf, ListFuzzi);
       //-------------------
     FINALLY
       FreeAndNil(ListPropBuf);
     END;
  end;
end;
function TES_bayes.Obj_Recognize(ListProp:TStrings; ListFuzzi:TStrings=nil):integer;
//  (    -   )
Var
  J :integer;
  YesNext:boolean;
begin
  Result:=-1;
  if Assigned(ListFuzzi) then ListFuzzi.Clear;
  YesNext:=false;
  if fRules<>nil then begin
     if fObjList<>nil then begin
        if fPropList<>nil then begin
           if (fPropCount>1) and (fObjCount>1) then begin
              if Assigned(ListProp) then begin
                 if ListProp.Count=fPropCount then begin
                    YesNext:=true;
                 end;
              end;
           end;
        end;
     end;
  end;
  if YesNext then begin
     //-------------------
     //"" 
     ObjList_TrainInfo_Clear;
     //-------------------
     //-------------------
     //  ,
     //   ListProp,
     //   
     PropsValue_from_TStrings(ListProp);
     //-------------------
     //-------------------
     //      
     ObjList_Ratings_Calc;
     //-------------------
     //-------------------
     //    
     //(       )
     Obj_Rating_Best_Find;
     Result:=fObjBest_J;
     //-------------------
     //-------------------
     //     
     //(       )
     for J:=0 to (fObjCount-1) do
      begin
       if fObjList[J].Rating>=fObjBest_Rating then begin
          if Assigned(ListFuzzi) then ListFuzzi.Add(IntToStr(J));
       end;
     end;
     //-------------------
     //-------------------
     //  
     Obj_Rating_Percent_Recalc;
     //-------------------
  end;
end;
//****************************
//****************************
//****************************



//****************************
//****************************
function iPower_10(N:integer):int64;
// 10   N (   )
Var
  i:integer;
begin
  Result:=0;
  if n>0 then begin
     Result:=1;
     for i:=1 to N do
      begin
        Result:=Result*10;
     end;
  end;
end;
function RoundTo(V:extended;iRoundTo:integer=2):extended;
//     
Var
  Sx:string;
  N,iRes : int64;
begin
  Result:=V;
  if iRoundTo>0 then begin
     N:=iPower_10(iRoundTo);
     if N>0 then begin
        iRes:=round(Result*N);
        Result:=iRes/N;
     end;
  end
  else begin
     Result:=round(V);
  end;
end;
//****************************
//****************************


end.



